<%@ include file="/WEB-INF/taglibs.jspf" %>
<%@ taglib tagdir="/WEB-INF/tags/file" prefix="file" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <%@ include file="/WEB-INF/jspf/meta.jspf" %>
    <title><fmt:message key="title" /></title>
    <tags:style url="/css/base.css" />
    <tags:style url="/css/content.css" version="${buildVersion}" />
    <%@ include file="/WEB-INF/jsp/view/js/init.jspf" %>
    <%@ include file="/WEB-INF/jsp/view/js/initFileList.jspf" %>
</head>

<body>
<%@ include file="/WEB-INF/jspf/js-enable.jspf"%>
<%@ include file="loginInfo.jspf"%>
<%@ include file="html/logo.jspf"%>

<tags:responseResult result="${requestScope.responseResult}" />

<%@ include file="html/buttonsBar.jspf" %>
<%@ include file="/WEB-INF/jsp/upload/view.jspf" %>

<c:if test="${requestScope.isShowSearch}">
    <%@ include file="search/form.jspf" %>
</c:if>
<div class="spacer"></div>
<div id="path"><tags:breadcrumbs workingDir="${requestScope.workingDir}" /></div>

<table id="list">
    <col class="small" /><col width="50%" /><col width="19%" class="tar" /><col width="30%" class="tac"/>
    <thead>
    <tr>
        <tags:input type="checkbox" name="all" id="selectall" value="all" disabled="${fn:length(requestScope.files) == 0}">
            <jsp:attribute name="template">
                <th>${inputTag}</th>
            </jsp:attribute>
        </tags:input>
        <th><fmt:message key="header.name" /></th>
        <th><fmt:message key="header.size" /></th>
        <th><fmt:message key="header.date" /></th>
    </tr>
    </thead>
    <tbody>
        <c:if test="${fn:length(requestScope.workingDir) gt 0 and fn:startsWith(requestScope.workingDir, '/')}">
            <tr class="sel">
                <td>&nbsp;</td>
                <td colspan="3"><span id="cdup">[..]</span>
                    <tags:link url="cdup" id="parentdir" onclick="changeToParentDirectoryAction(); return false;">
                        <fmt:message key="link.parent.directory" />
                    </tags:link>
                </td>
            </tr>
        </c:if>
        <c:forEach var="file" items="${requestScope.files}">
            <tr>
                <td><input type="checkbox"/></td>
                <td><file:link name="${file.name}" path="${file.path}" directory="${file.directory}" cssClass="${file.cssClass}"/></td>
                <td align="right"><c:choose>
                        <c:when test="${file.directory}"><fmt:message key="view.type.directory"/></c:when>
                        <c:otherwise><span class="erasable">${file.size}</span><file:size value="${file.size}"/></c:otherwise>
                    </c:choose></td>
                <td align="center"><span class="erasable">${file.time}</span><file:date time="${file.time}" /></td>
            </tr>
        </c:forEach>
    </tbody>
</table>

<%@ include file="/WEB-INF/jsp/view/inactivity/service.jspf" %>

</body>
</html>