function EmailFile(url) {
    this._constructor(url);
}
(function() { // create local scope;

    EmailFile.URL = "";
    EmailFile.FORM_NAME = "";

    EmailFile.prototype = {

        url: null,
        dialog: null,
        channel: null,
        form: null,

        _constructor: function(url) {
            this.url = url || EmailFile.URL;
            this.dialog = new EmailFileDialog(this);
            this.channel = new IFrameChannel("EmailFileChannel");
            this.channel.setPreventCaching(true);
        },

        compose: function(filenames) {
            this.channel.open(this.url, IFrameChannel.Method.POST);
            this.dialog.setContent(this.channel.asElement());
            var viewport = document.viewport.getDimensions();
            this.dialog.setSize(viewport.width * 0.5, viewport.height * 0.73);
            this.dialog.setButtonEnabled(ModalDialog.BUTTON_OK, false);
            this.dialog.setVisible(true);

            this.channel.addLoadListener(this.onFormLoaded.bind(this));
            this.channel.send({filename: filenames});
        },

        onSubmit: function() {
            this.dialog.setButtonEnabled(ModalDialog.BUTTON_OK, false);

            if (this.form != null) {
                this.form.submit();
            }
        },

        onCancel: function() {
            this.dialog.setVisible(false);
            this.channel.close();
        },

        onEmailSent: function() {
            this.channel.close();
            this.dialog.setVisible(false);

            alert(EmailFileDialog.Messages.SUCCESS);
        },

        onFormLoaded: function() {
            this.form = this._getFormNamed(EmailFile.FORM_NAME);
            Utils.setStyle(this.channel.asElement(), {width: "100%", height: "100%", display: "block"});
            this.dialog.setButtonEnabled(ModalDialog.BUTTON_OK, true);
        },

        _getFormNamed: function(name) {
            var forms = this.channel.asDocument().forms;
            for (var i = 0; i < forms.length; ++i) {
                var candidate = forms[i];
                if (candidate.name == name) {
                    return candidate;
                }
            }
            return null;
        }

    };
})();