function GenerateKeyDialog(listener) {
    this._constructor(listener);
}
(function() { // create local scope;

    GenerateKeyDialog.Buttons = {OK: 'OK', CANCEL: 'Cancel'};
    GenerateKeyDialog.Labels = {KEY_TYPE: "Type", KEY_LENGTH: "Length", FILE_TYPE: "File type", FILE_PASSWORD: "File password", CONFIRM_PASSWORD: "Confirm password"};

    GenerateKeyDialog.prototype = {

        dialog: null,
        messageHolder: null,
        listener: null,

        _constructor: function(listener) {
            this.listener = listener;
            this.dialog = new ModalDialog("GenerateKeyDialog");
            this._compose();
        },

        setContent: function(content) {
            this.dialog.getContent().appendChild(content);
        },

        setMessage: function(message) {
            if (message != null) {
                while (this.messageHolder.hasChildNodes()) {
                    this.messageHolder.removeChild(this.messageHolder.lastChild);
                }
                this.messageHolder.appendChild(document.createTextNode(message));
                Utils.setStyle(this.messageHolder, {display: "block"});
            } else {
                Utils.setStyle(this.messageHolder, {display: "none"});
            }
        },

        setTitle: function(title) {
            this.dialog.setTitle(title);
        },

        setButtonEnabled: function(name, enable) {
            this.dialog.setButtonEnabled(name, enable);
        },

        isVisible: function() {
            return this.dialog.isVisible();
        },

        setVisible: function(visible) {
            this.dialog.setVisible(visible);
            this._registerKeyHandlers();
        },

        setSize: function(width, height) {
            this.dialog.setSize(width,  height);
        },

        pack: function() {
            this.dialog.pack();
        },

        onSubmit: function() {
            this.listener.onSubmit();
        },

        onCancel: function() {
            this.listener.onCancel();
        },

        processKeyEvent: function(ke) {
            var code = ke.getKeyCode();
            switch (code) {
                case KeyEvent.VK_ESCAPE:
                    ke.cancel();
                    this.onCancel();
                    break;
            }
        },

        _registerKeyHandlers: function() {
            var km = KeyboardManager.getInstance();
            if (this.isVisible()) {
                km.registerHandler(KeyEvent.VK_ESCAPE, this);
            } else {
                km.unregisterHandler(KeyEvent.VK_ESCAPE, this);
            }
        },

        _compose: function() {
            this.messageHolder = this.dialog.getContent().appendChild(document.createElement(Tag.DIV));
            Utils.setStyle(this.messageHolder, {display: "none"});

            var thisObj = this;
            this.dialog.addButton(ModalDialog.BUTTON_OK, GenerateKeyDialog.Buttons.OK, function() { thisObj.onSubmit(); });
            this.dialog.addButton(ModalDialog.BUTTON_CANCEL, GenerateKeyDialog.Buttons.CANCEL, function() { thisObj.onCancel(); });
            this.dialog.setSize(580, 320);
        }

    };
})();