function ManageUsersPane(form) {
    this._constructor(form);
}(function() { // create local scope;

    ManageUsersPane.USER_INPUT_NAME = "login";
    ManageUsersPane.ADD_BUTTON_ID = "adduser";
    ManageUsersPane.DELETE_BUTTON_ID = "deleteuser";
    ManageUsersPane.SELECT_ALL_BOX_ID = "selectall";

    ManageUsersPane.prototype = {

        form: null,
        userBoxs: null,
        selectAllBox: null,
        deleteButton: null,
        dialog: null,

        _constructor: function(form) {
            this.form = form;
            this.userBoxs = Utils.getFormInputs(this.form, Tag.INPUT_TYPE_CHECKBOX, ManageUsersPane.USER_INPUT_NAME);
            this.selectAllBox = $(ManageUsersPane.SELECT_ALL_BOX_ID);
            this.deleteButton = $(ManageUsersPane.DELETE_BUTTON_ID);
            this.dialog = new DeleteUserDialog();

            var thisObj = this;
            this.dialog.onSubmit = function() {
                this.setVisible(false);
                thisObj.doDeleteUser(this.isDeleteOwnedAccounts());
            }

            this._attachEvent();
            this._update();
        },

        getSelectedCount: function() {
            var count = 0;
            for (var i = 0, size = this.userBoxs.length; i < size; ++i) {
                if (this.userBoxs[i].checked) { count++; }
            }
            return count;
        },

        doDeleteUser: function(isDeleteOwnedAccounts) {
            new Action("deleteuser", this.form).perform({
                deleteOwnedAccounts: isDeleteOwnedAccounts
            });
        },

        handleDeleteUser: function() {
            if (this.getSelectedCount() != 0) {
                this.dialog.setVisible(true);
            }
        },

        handleSelectAll: function() {
            var selected = this.selectAllBox.checked;
            for (var i = 0, size = this.userBoxs.length; i < size; ++i) {
                this.userBoxs[i].checked = selected;
            }
            this._update();
        },

        _attachEvent: function() {
            var thisObj = this;
            for (var i = 0; i < this.userBoxs.length; ++i) {
                this.userBoxs[i].onclick = function() { thisObj._update(); }
            }

            this.deleteButton.onclick = function() { thisObj.handleDeleteUser(); return false;}
            this.selectAllBox.onclick = function() { thisObj.handleSelectAll(); }
        },

        _update: function() {
            var selectedCount = this.getSelectedCount();
            this.selectAllBox.checked = (this.userBoxs.length == selectedCount);
            Utils.setEnabled(this.deleteButton, selectedCount != 0);
        }
    }
})();