function UploadView(listener) {
    this._constructor(listener);
}
(function() { // create local scope;

    UploadView.Css = {BUTTON_DISABLED: "disabled"};

    UploadView.prototype = {

        addButton: null,
        removeButton: null,
        fileConter: null,
        fileList: null,
        uploadButton: null,

        _constructor: function(listener) {
            this.addButton = $("addfile");
            this.removeButton = $("removefile");
            this.fileCounter = $("filecounter");
            this.uploadButton = $("startupload");
            this.fileList = new List($("filelist"));

            this.fileList.addPropertyChangeListener({
                propertyChange: function(event) {
                    if (event.propertyName == List.PCS_SELECTED_INDEX) {
                        this._update();
                    }
                }.bind(this)
            });

            this.addButton.onclick = function() { return false; };
            this.removeButton.onclick = function() { listener.onFileRemove(this._getSelectedFiles()); return false; }.bind(this);
            this.uploadButton.onclick = listener.onSubmit.bind(listener);

            this._update();
        },

        addFile: function(filename) {
            this.fileList.addItem(filename, filename);
            this._update();
        },

        removeFile: function(filename) {
            this.fileList.removeItem(filename);
            this._update();
        },

        getForm: function() {
            return this.uploadButton.form;
        },

        getOverflowElement: function() {
            return this.addButton;
        },

        getFileCount: function() {
            return this.fileList.getItemCount();
        },

        getFilenames: function() {
            return this._itemsToFilenames(this.fileList.getItems());
        },

        clear: function() {
            var items = this.fileList.getItems();
            while (items.length > 0) {
                this.fileList.removeItem(items.pop());
            }
            this._update();
        },

        _getSelectedFiles: function() {
            return this._itemsToFilenames(this.fileList.getSelectedItems());
        },

        _itemsToFilenames: function(items) {
            var result = new Array(items.length);
            for (var i = 0; i < items.length; ++i) {
                result[i] = items[i].value;
            }
            return result;
        },

        _update: function() {
            var count = this.fileList.getItemCount();
            this.fileCounter.innerHTML = count;
            Utils.setEnabled(this.removeButton, this.fileList.getSelectedIndex() != -1, UploadView.Css.BUTTON_DISABLED);
            Utils.setEnabled(this.uploadButton, count != 0, UploadView.Css.BUTTON_DISABLED);
        },

        toString: function() {
            return "UploadView";
        }
    };

})();